% MMN and load
clear
cd('C:\Users\SWIENS\Documents\Malina\Study2\');
rawdir=('C:\Users\SWIENS\Documents\Malina\Study2\fieldtrip\bdf');

load('C:\Users\SWIENS\Documents\Malina\Study2\fieldtrip\Constants','fps');

% problems with fp=4 and 35: fixed here and in EEG.
Adata=[];
%Bdata=[]; %split half reliability
for f=1:length(fps)
    fpnow = fps(f);
    filename = fullfile(rawdir,['fp',num2str(fpnow),'.txt']);

    disp(['processing subject ... ', sprintf('%d',fpnow)]);
    
    Adata(end+1,1)=fpnow;
   
    %     Data 11/05/2014 12:12:11
    %     High and low load in blocks of 250 trials
    %     Starting Load condition is :	1	; 1=low (ppt=+10), 2=high (ppt= +20)
    %     Deviant: 1 (yes, ppt=+5), 0 (no)
    %     Respnow: 1 (yes, ppt=+100), 0 (no)
    %     Trial	Block	Load	PPT	Dev	Respnow	Resp	RT
    % 1	1	1	115	1	1	1	425.4
    % 2	1	1	10	0	0	0	0
    % 3	1	1	10	0	0	0	0
    % 4	1	1	15	1	0	0	0
    % 5	1	1	10	0	0	0	0
    % 6	1	1	110	0	1	1	457.3
    % 7	1	1	10	0	0	0	0

    clear indata
    % nowfile=[rawdir,'\fp',sprintf('%d',fpnow),'\Malinastudy1_data.txt'];
    disp(['processing file ... ', filename]);
    fid = fopen(filename);
    indata = textscan(fid, '%f %f %f %f %f %f %f %f', 'headerlines', 6);
    fclose(fid);
    indata=cell2mat(indata);

    [gn,gmean,gnum]=grpstats(indata(:,3),indata(:,2),{'gname','mean','numel'});
    % Block in col 2 is from 1 to 10
    display([str2double(gn),gmean,gnum])
    if fpnow ~= 35 %had problems with recordings (fixed for EEG)
        if (gnum ~= repmat(250,10,1)) 
            error('... Not 10 blocks of 250 trials')
        end
    end
    
    % low load or high load first?
    if indata(1,3) == 1
        Adata(end,2) = 1; 
    elseif indata(1,3) == 2
        Adata(end,2) = 2;
    end
    
    %     Trial	Block	Load	PPT	Dev	Respnow	Resp	RT
    % hits
    tdata=indata(indata(:,6)==1 & indata(:,7)==1,:);
    % exclude hits with RT < 200;
    tmp=tdata(:,8)<200;
    hitsRTfast = sum(tmp);
    tdata(tmp,:)=[];
    [hname,hits,hitsRT]=grpstats(tdata(:,8),tdata(:,4),{'gname','numel','mean'});
    % RT in col 8 broken down by condition
    hitsper = hits./[200;50;200;50]*100;
    
    tf=ismember([110,115,120,125],str2double(hname'));
    tmp1=zeros(1,4);
    tmp1(tf)=hits';
    tmp2=zeros(1,4);
    tmp2(tf)=hitsper';
    tmp3=zeros(1,4);
    tmp3(tf)=hitsRT;
    Adata(end,3:14)=[tmp1,tmp2,tmp3];

%     %     Trial	Block	Load	PPT	Dev	Respnow	Resp	RT
%     % hits split half reliability
%     tdata=indata(indata(:,6)==1,:);
%     for f=[110,115,120,125];
%         tmp=find(tdata(:,4)==f);
%         tmp1=tmp(1:2:length(tmp));
%         tmp2=tmp(2:2:length(tmp));
%         tdata(tmp1,9)=1;
%         tdata(tmp2,9)=2;
%     end
%     if sum(tdata(:,9)==0)>0
%         error('Split half problem: Some trials unaccounted for')
%     end
%     % exclude hits with RT < 200;
%     tmp=tdata(:,8)<200;
%     tdata(tmp,:)=[];
%     [hname2,hits2,hitsRT2]=grpstats(tdata(:,8),tdata(:,[9,4]),{'gname','numel','mean'});
%     % RT in col 8 broken down by condition
%     hitsper2 = hits2./[100;25;100;25;100;25;100;25]*100;
%     if ~isequal([110,115,120,125,110,115,120,125],str2double(hname2(:,2)'))
%         error('Split half problem: Not all conditions detected.')
%     end
%     Bdata=[Bdata;hits2',hitsper2',hitsRT2'];
        
    % false alarms
    tdata=indata(indata(:,6)==0 & indata(:,7)==1,:);
    % exclude fa with RT < 200;
    tmp=tdata(:,8)<200;
    faRTfast = sum(tmp);
    tdata(tmp,:)=[];
    [fname,faal]=grpstats(tdata(:,8),tdata(:,4),{'gname','numel'});
    tf=ismember([10,15,20,25],str2double(fname'));
    
    tmp1=zeros(1,4);
    tmp1(tf)=faal'; 
    Adata(end,15:20)=[tmp1, hitsRTfast, faRTfast];
end
Adata(:,15:18)=Adata(:,15:18)*100./repmat([800,200,800,200],size(Adata,1),1);

Alabels=[];
Alabels{1}='Fp';
Alabels{2}='Firstload';
t1={'Hitnum_lo_stn','Hitnum_lo_dev','Hitnum_hi_stn','Hitnum_hi_dev'};
t2={'Hitperc_lo_stn','Hitperc_lo_dev','Hitperc_hi_stn','Hitperc_hi_dev'};
t3={'HitRT_lo_stn','HitRT_lo_dev','HitRT_hi_stn','HitRT_hi_dev'};
t4={'Falperc_lo_stn','Falperc_lo_dev','Falperc_hi_stn','Falperc_hi_dev'};
Alabels=[Alabels,t1,t2,t3,t4,'HitsRTfast','FaRTfast']';
Abeh = dataset({Adata,Alabels{:}});
if exist('BehavioralData.xls','file')
    delete('BehavioralData.xls')
end
export(Abeh,'XLSfile','BehavioralData');

% Blabels=[];
% t1={'Hitnum_lo_stn1','Hitnum_lo_dev1','Hitnum_hi_stn1','Hitnum_hi_dev1'};
% t2={'Hitnum_lo_stn2','Hitnum_lo_dev2','Hitnum_hi_stn2','Hitnum_hi_dev2'};
% t3={'Hitperc_lo_stn1','Hitperc_lo_dev1','Hitperc_hi_stn1','Hitperc_hi_dev1'};
% t4={'Hitperc_lo_stn2','Hitperc_lo_dev2','Hitperc_hi_stn2','Hitperc_hi_dev2'};
% t5={'HitRT_lo_stn1','HitRT_lo_dev1','HitRT_hi_stn1','HitRT_hi_dev1'};
% t6={'HitRT_lo_stn2','HitRT_lo_dev2','HitRT_hi_stn2','HitRT_hi_dev2'};
% Blabels=[Blabels,t1,t2,t3,t4,t5,t6]';

save BehavioralData Adata Alabels Abeh fps 
% Bdata Blabels

% mean(Adata(:,end-1:end))
% boxplot(Adata(:,end-1:end),'notch','on','labels',Alabels(19:20))
% title('Some false alarms < 200 ms RT--probably late responses')
% orient landscape
% saveas(gcf,'aFig Beh some early false alarms n=28.pdf')
% This is no biggy bc we talk about no more than 7 fast fa out of 2000 trials
% but, this depends on the overall number of false alarms.

nsub=length(fps);
tmp = repmat([201,51,201,51],nsub,1);
hrc = ([Abeh.Hitnum_lo_stn, Abeh.Hitnum_lo_dev, Abeh.Hitnum_hi_stn, Abeh.Hitnum_hi_dev]+0.5)./tmp;

tmp = repmat([800,200,800,200],nsub,1);
fac = [Abeh.Falperc_lo_stn, Abeh.Falperc_lo_dev, Abeh.Falperc_hi_stn, Abeh.Falperc_hi_dev].*tmp/100;
tmp = repmat([801,201,801,201],nsub,1);
fac = (fac+0.5)./tmp;

% Compute d' and C
% d prime
dpr=norminv(hrc,0,1)-norminv(fac,0,1);
% criterion C
critC=(norminv(hrc,0,1)+norminv(fac,0,1))./-2;
